// APPHelper.cpp: implementation of the APPHelper class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <oleauto.h>//for BSTR support
#include "APPHelper.h"//   Aml Pages

#ifdef _AFX
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
#endif//#ifdef _AFX

//  MFC-
// MFC-  ASSERT  
#ifndef ASSERT
#ifdef _DEBUG
	#include <assert.h>
	#define ASSERT(X) assert(X)
#else// #ifdef _DEBUG
	#define ASSERT(X)
#endif//#ifdef _DEBUG
#endif//#ifndef ASSERT

//  MFC-
// MFC-  TRACE  
#ifndef TRACE
	#ifdef _DEBUG
		#define TRACE(X) OutputDebugString(X)
	#else
		#define TRACE(X) 
	#endif
#endif

/*
       
   Aml Pages

-  ,     
Aml Pages,      .
      Aml Pages (.. GetProcAddress  NULL)
-  
 FALSE (     )

   Aml Pages    APC_
   AmlPages.exe

     :
HMODULE hModule=GetModuleHandle(NULL);// HMODULE AmlPages.exe
GetProcAddress(hModule,_);//    [_]
*/

#define CHECK_STR_PTR(lpsz)	\
	ASSERT(lpsz);	\
	ASSERT(!::IsBadStringPtr(lpsz,INFINITE));

#define CHECK_PTR(ptr,TYPE)	\
	ASSERT(ptr);	\
	ASSERT(!::IsBadReadPtr((void*)ptr,sizeof(TYPE)));	\
	ASSERT(!::IsBadWritePtr((void*)ptr,sizeof(TYPE)));	
	

HWND APPHelper::GetMainHWND()
{
	/* HWND   Aml Pages*/
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETMAINWND pfn=(PFUNC_APC_GETMAINWND)GetProcAddress(h,TEXT("APC_GetMainWnd"));

	if (pfn) return pfn();
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetMainWnd function from AmlPages.exe\n"));
		return NULL;
	}
}

BOOL APPHelper::ConvertText(LPCTSTR lpszInText// 
							,BSTR* pbstrOutText//  (    )
							, const BOOL bRTF2Text//TRUE -  RTF  Plain Text, FALSE  Plain Text  RTF
							)
{
	CHECK_STR_PTR(lpszInText);
	CHECK_PTR(pbstrOutText,BSTR);

	/*  RTF<->PlainText*/
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_CONVERTTEXT pfn=(PFUNC_APC_CONVERTTEXT)GetProcAddress(h,TEXT("APC_ConvertText"));
	if (pfn)
		return pfn(lpszInText,pbstrOutText,bRTF2Text);
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_ConvertText function from AmlPages.exe\n"));
		return FALSE;
	}
}

// MessageBox  
BOOL APPHelper::MessageBoxWithCheckBox(
	LPCTSTR lpszText// MessageBox
	,UINT uType// MessageBox
	,LPCTSTR lpszCheckBoxText// 
	,BOOL* pbChecked// (in-out,    NULL,     
	// )
	,int* pnRet//   MessageBox, 
	//   NULL,     
	)
{
	CHECK_STR_PTR(lpszText);
	CHECK_STR_PTR(lpszCheckBoxText);
	//-  TRUE,     FALSE  
	//  MessageBox    .  pbChecked  pnRet
	CHECK_PTR(pbChecked,BOOL);
	CHECK_PTR(pnRet,int);

	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_MESSAGEBOXWITHCHECKBOX pfn=
		(PFUNC_APC_MESSAGEBOXWITHCHECKBOX)GetProcAddress(h,TEXT("APC_MessageBoxWithCheckBox"));
	if (pfn) {
		(*pnRet)=pfn(lpszText,uType,lpszCheckBoxText,pbChecked);
		return TRUE;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_MessageBoxWithCheckBox function from AmlPages.exe\n"));
		return FALSE;
	}
}

//  - 
BOOL APPHelper::DisplayPasswordDialog(
     BSTR* pbstrPassword//out,   ,   ,    NULL
	,BOOL bSetupPassword//TRUE,   , FALSE     ( ,     )
	,BOOL bTopMost//     (TRUE)
	,LPCTSTR lpszPrevPassword// ,  NULL .  
	,BOOL bShowOnEnter//    (TRUE),  FALSE   ()
	,LPCTSTR lpszTitle)//  
{
	CHECK_PTR(pbstrPassword,BSTR);
	// FALSE    ,    
	// TRUE        ( OK)
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_DISPLAYPASSWORDDIALOG pfn
		=(PFUNC_APC_DISPLAYPASSWORDDIALOG)GetProcAddress(h,TEXT("APC_DisplayPasswordDialog"));
	if (pfn) {
		BOOL b=pfn(pbstrPassword,bSetupPassword,bTopMost,lpszPrevPassword,bShowOnEnter,lpszTitle);
		return b;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_DisplayPasswordDialog function from AmlPages.exe\n"));
		return FALSE;
	}
}

//   Aml Pages (  ,      )
UINT APPHelper::GetAmlPagesBuildNumber()
{
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETAMLPAGESBUILDNUMBER pfn=
		(PFUNC_APC_GETAMLPAGESBUILDNUMBER)GetProcAddress(h,TEXT("APC_GetAmlPagesBuildNumber"));
	if (pfn) {
		const UINT nRet=pfn();
		return nRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetAmlPagesBuildNumber function from AmlPages.exe\n"));
		return 0;
	}
}

//        lpszPathName
BOOL APPHelper::GetModuleVersionInfo(
	LPCTSTR lpszPathName
	, AML_MODULEVERSIONINFO *pVersionInfo)
{
	CHECK_STR_PTR(lpszPathName);
	CHECK_PTR(pVersionInfo,AML_MODULEVERSIONINFO);
	// TRUE   
	ASSERT(pVersionInfo);
	if (!pVersionInfo) return FALSE;

	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETMODULEVERSIONINFO pfn=
		(PFUNC_APC_GETMODULEVERSIONINFO)GetProcAddress(h,TEXT("APC_GetModuleVersionInfo"));
	if (pfn) {
		const BOOL bRet=pfn(lpszPathName,pVersionInfo);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetModuleVersionInfo function from AmlPages.exe\n"));
		return FALSE;
	}
}

//   
BOOL APPHelper::ReReadPluginsInfo(
								  HMODULE hModule// NULL  , 
								  // -NULL       hModule
								  )
{
	//TRUE-  
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_REREADPLUGINSINFO pfn=
		(PFUNC_APC_REREADPLUGINSINFO)GetProcAddress(h,TEXT("APC_ReReadPluginsInfo"));
	if (pfn) {
		const BOOL bRet=pfn(hModule);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_ReReadPluginsInfo function from AmlPages.exe\n"));
		return FALSE;
	}
}

//    Aml Pages, 
//  AML_OPTIONS   
//.  plugins.h, 
BOOL APPHelper::GetOptions(AML_OPTIONS *pOpt)
{
	//TRUE   
	//  , pOpt -    NULL
	CHECK_PTR(pOpt,AML_OPTIONS);
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETOPTIONS pfn=(PFUNC_APC_GETOPTIONS)GetProcAddress(h,TEXT("APC_GetOptions"));
	if (pfn) {
		const BOOL bRet=pfn(pOpt);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetOptions function from AmlPages.exe\n"));
		return FALSE;
	}
}

//   
// .  plugins.h
BOOL APPHelper::GetAutoTextCommand(AML_AUTOTEXTCOMMAND *pCmd)
{
	//  pCmd    
	//TRUE -   
	CHECK_PTR(pCmd,AML_AUTOTEXTCOMMAND );
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETAUTOTEXTCOMMAND pfn=
		(PFUNC_APC_GETAUTOTEXTCOMMAND)GetProcAddress(h,TEXT("APC_GetAutoTextCommand"));
	if (pfn) {
		const BOOL bRet=pfn(pCmd);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetAutoTextCommand function from AmlPages.exe\n"));
		return FALSE;
	}
}

//   
// .  plugins.h
BOOL APPHelper::PluginAbout(AML_PLUGINABOUTINFO *pInfo)
{
	CHECK_PTR(pInfo,AML_PLUGINABOUTINFO);
	//  pInfo    
	//TRUE -   
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_PLUGINABOUT pfn=
		(PFUNC_APC_PLUGINABOUT)GetProcAddress(h,TEXT("APC_PluginAbout"));
	if (pfn) {
		const BOOL bRet=pfn(pInfo);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_PluginAbout function from AmlPages.exe\n"));
		return FALSE;
	}
}

//-    RichEdit
static
BOOL RichInOut(AML_RICHEDITIO *p)
{
	CHECK_PTR(p,AML_RICHEDITIO);
	//    
	//TRUE -   
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_RICHINOUT pfn=
		(PFUNC_APC_RICHINOUT)GetProcAddress(h,TEXT("APC_RichInOut"));
	if (pfn) {
		const BOOL bRet=pfn(p);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_RichInOut function from AmlPages.exe\n"));
		return FALSE;
	}
}


//    RichEdit
BOOL APPHelper::RichIn(AML_RICHEDITIO *p)
{
	//    
	//TRUE -   
	CHECK_PTR(p,AML_RICHEDITIO);
	if (!p)
		return FALSE;
	
	p->dwFlags|=APFRIO_IN;
	return RichInOut(p);
}

//    RichEdit
BOOL APPHelper::RichOut(AML_RICHEDITIO *p)
{
	//    
	//TRUE -   
	CHECK_PTR(p,AML_RICHEDITIO);
	if (!p) return FALSE;
	
	ASSERT(0==(p->dwFlags & APFRIO_IN));
	if (p->dwFlags & APFRIO_IN)
		p->dwFlags^=APFRIO_IN;

	return RichInOut(p);

}

//      hModule
BOOL APPHelper::GetModuleVersionInfoEx(HMODULE hModule
									   , AML_MODULEVERSIONINFO *pInfo)
{
	//    
	//TRUE -   
	ASSERT(hModule);
	CHECK_PTR(pInfo,AML_MODULEVERSIONINFO );
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_GETMODULEVERSIONINFOEX pfn=
		(PFUNC_APC_GETMODULEVERSIONINFOEX)GetProcAddress(h,TEXT("APC_GetModuleVersionInfoEx"));
	if (pfn) {
		const BOOL bRet=pfn(hModule,pInfo);
		return bRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_GetModuleVersionInfoEx function from AmlPages.exe\n"));
		return FALSE;
	}
}

//MessageBox  radio-buttons
BOOL APPHelper::MessageBoxWithRadioBox(AML_MBRADIOINFO *pInfo)
{
	//  pInfo  ,      	
	CHECK_PTR(pInfo,AML_MBRADIOINFO);;//    NULL
	ASSERT(pInfo->bstrText);//  MessageBox    NULL
	ASSERT(pInfo->bstrButtonsText);//        NULL
	//       "Radio Button Text 0\nRadio Button Text 1\n"
	//      "\n"+1,  "\n"   ,  

	PFUNC_APC_MESSAGEBOXWITHRADIO pfn=(PFUNC_APC_MESSAGEBOXWITHRADIO)GetProcAddress(GetModuleHandle(NULL)
		,TEXT("APC_MessageBoxWithRadioBox"));
	if (pfn) {
		const BOOL b=pfn(pInfo);
		return b;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_MessageBoxWithRadioBox function from AmlPages.exe\n"));
		return FALSE;
	}
}

/* MessageBox   */
BOOL APPHelper::MessageBoxWithCheckBoxEx(AML_MBCHECKINFO *pInfo)
{
	CHECK_PTR(pInfo,AML_MBCHECKINFO);/*  ?*/
	ASSERT(pInfo->bstrText);/* . MessageBox   */
	ASSERT(pInfo->bstrButtonsText);/*    */
	ASSERT(pInfo->cbSize);/*    sizeof(AML_MBCHECKINFO)*/
	ASSERT(pInfo->pbChecked);/*    */
	
	PFUNC_APC_MESSAGEBOXWITHCHECKBOXEX pfn=(PFUNC_APC_MESSAGEBOXWITHCHECKBOXEX)GetProcAddress(
		GetModuleHandle(NULL),TEXT("APC_MessageBoxWithCheckBoxEx"));
	if (pfn)
		return pfn(pInfo);
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_MessageBoxWithCheckBoxEx function from AmlPages.exe\n"));
		return FALSE;
	}
}

LRESULT APPHelper::Command(UINT nCmd, WPARAM wParam, LPARAM lParam)
{
	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_COMMAND pfn=
		(PFUNC_APC_COMMAND)GetProcAddress(h,TEXT("APC_Command"));
	if (pfn) {
		const LRESULT nRet=pfn(nCmd,wParam,lParam);
		return nRet;
	}
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_COMMAND function from AmlPages.exe\n"));
		return 0;
	}
}

BOOL APPHelper::AddExtraInfo(WORD wDocID, AML_EXTRAINFO* p)
{
	ASSERT(!IsBadReadPtr(p,sizeof(AML_EXTRAINFO)));

	HMODULE h=GetModuleHandle(NULL);
	PFUNC_APC_ADDEXTRAINFO pfn=
		(PFUNC_APC_ADDEXTRAINFO )GetProcAddress(h,TEXT("APC_AddExtraInfo"));
	if (pfn) {
		const BOOL b=pfn(wDocID,p);
		return b;
	}
	else
		return FALSE;

}

BOOL APPHelper::AddStringToExtraInfo(WORD wDocID,LPCTSTR lpsz, LPCTSTR lpszInfoID, const int nPageID)
{
	ASSERT(!IsBadStringPtr(lpsz,INFINITE));
	ASSERT(strlen(lpsz));
#ifdef _DEBUG
	if (lpszInfoID) {
		ASSERT(!IsBadStringPtr(lpszInfoID,INFINITE));
		ASSERT(strlen(lpszInfoID));
	}
#endif

	AML_EXTRAINFO ae;
	ae.dwInfoSize=strlen(lpsz);
	ae.pInfo=(char*)lpsz;
	ae.lpszInfoID=lpszInfoID;
	ae.nPageID=nPageID;

	return AddExtraInfo(wDocID,&ae);
}

static
BSTR BSTRFromLPCTSTR(LPCTSTR lpsz)
{
	if ((IsBadStringPtr(lpsz,INFINITE)) || (!strlen(lpsz))) return NULL;

	const int nLen = MultiByteToWideChar(CP_ACP, 0, lpsz,
		strlen(lpsz) ,NULL, NULL);
	
	BSTR bstr = ::SysAllocStringLen(NULL, nLen);
	
	if (bstr )
		MultiByteToWideChar(CP_ACP, 0, lpsz, strlen(lpsz),bstr, nLen);

	return bstr;
}


BOOL APPHelper::PluginAbout(
	LPCTSTR lpszAbout
	, LPCTSTR lpszCopy
	, LPCTSTR lpszLink
	, LPCTSTR lpszNameVersion
	, LPCTSTR lpszURLToolTip
	, LPCTSTR lpszTitle
	, const HICON hIcon
	, LPCTSTR lpszLinkText)
{
	AML_PLUGINABOUTINFO pa;
	pa.bstrAbout=BSTRFromLPCTSTR(lpszAbout);
	pa.bstrCopyrights=BSTRFromLPCTSTR(lpszCopy);
	pa.bstrLink=BSTRFromLPCTSTR(lpszLink);
	pa.bstrNameVersion=BSTRFromLPCTSTR(lpszNameVersion);
	pa.bstrTitle=BSTRFromLPCTSTR(lpszTitle);
	pa.bstrURLToolTip=BSTRFromLPCTSTR(lpszURLToolTip);
	pa.lpszLinkText=lpszLinkText;
	pa.hIcon=hIcon;

	const BOOL b=PluginAbout(&pa);
	if (pa.bstrAbout)
		SysFreeString(pa.bstrAbout);
	if (pa.bstrCopyrights)
		SysFreeString(pa.bstrCopyrights);
	if (pa.bstrLink)
		SysFreeString(pa.bstrLink);
	if (pa.bstrNameVersion)
		SysFreeString(pa.bstrNameVersion);
	if (pa.bstrTitle)
		SysFreeString(pa.bstrTitle);
	if (pa.bstrURLToolTip)
		SysFreeString(pa.bstrURLToolTip);

	return b;
}

//     Aml Pages
BOOL APPHelper::SetStatusBarText(BSTR bstr)
{
	//bstr    BSTR,     ,    NULL

	ASSERT(bstr);
	
	PFUNC_APC_SETSTATUSBARTEXT pfn=(PFUNC_APC_SETSTATUSBARTEXT)GetProcAddress(GetModuleHandle(NULL)
		,TEXT("APC_SetStatusBarText"));

	if (pfn)
		return pfn(bstr);
	else {
		TRACE(TEXT("WARNING: Cannot get pointer to APC_SetStatusBarText function from AmlPages.exe\n"));
		return FALSE;
	}
}

BOOL APPHelper::SetStatusBarText(LPCTSTR lpszText)
{
	ASSERT(!IsBadStringPtr(lpszText,INFINITE));
	ASSERT(strlen(lpszText));

	const BSTR bstr=BSTRFromLPCTSTR(lpszText);
	ASSERT(bstr);

	const BOOL b=APPHelper::SetStatusBarText(bstr);
	
	if(bstr)
		SysFreeString(bstr);

	return b;
}

BOOL APPHelper::RichInPlainTextAll(const HWND hwnd, LPCTSTR lpszText)
{
	return RichIn(hwnd,lpszText,true,false);
}

BOOL APPHelper::RichInPlainTextSel(const HWND hwnd, LPCTSTR lpszText)
{
	return RichIn(hwnd,lpszText,true,true);
}

BOOL APPHelper::RichInRTFTextAll(const HWND hwnd, LPCTSTR lpszText)
{
	return RichIn(hwnd,lpszText,false,false);
}

BOOL APPHelper::RichInRTFTextSel(const HWND hwnd, LPCTSTR lpszText)
{
	return RichIn(hwnd,lpszText,false,true);
}

BOOL APPHelper::RichIn(const HWND hwnd
					   , LPCTSTR lpszText
					   , const bool bAsPlainText
					   , const bool bSel)
{
	ASSERT(IsWindow(hwnd));
	ASSERT(!IsBadStringPtr(lpszText,INFINITE));
	ASSERT(strlen(lpszText));

	AML_RICHEDITIO io;
	io.bstrText=BSTRFromLPCTSTR(lpszText);
	io.hwndRichEdit=hwnd;
	if (bAsPlainText)
		io.dwFlags|=APFRIO_PLAINTEXT;
	if(bSel)
		io.dwFlags|=APFRIO_SEL;

	const BOOL b=RichIn(&io);
	if (io.bstrText)
		SysFreeString(io.bstrText);

	return b;
}

 int APPHelper::EnumExtraInfo(WORD wDocID
 							 , PFUNC_ENUMEXTRAINFOPROC pfn
 							 , LPARAM lParam
 							 , LPCTSTR lpszINFOID
 							 , int nPageID)
 {
 	ASSERT(!IsBadCodePtr((FARPROC)pfn));
 #ifdef _DEBUG
 	if (lpszINFOID) {
 		ASSERT(!IsBadStringPtr(lpszINFOID,INFINITE));
 		ASSERT(strlen(lpszINFOID));
 	}
 #endif
 
 	HMODULE h=GetModuleHandle(NULL);
 	PFUNC_APC_ENUMEXTRAINFO p=
 		(PFUNC_APC_ENUMEXTRAINFO)GetProcAddress(h,TEXT("APC_EnumExtraInfo"));
 	if (p) {
 		const int nRet=p(wDocID,pfn,lpszINFOID,nPageID,lParam);
 		return nRet;
 	}
 	else
 		return -1;
 }


BOOL APPHelper::RemoveExtraInfo(WORD wDocID, int nIndex)
{
	ASSERT(nIndex>=0);
 	HMODULE h=GetModuleHandle(NULL);
 	
	PFUNC_APC_REMOVEEXTRAINFO p=
		(PFUNC_APC_REMOVEEXTRAINFO)GetProcAddress(h,TEXT("APC_RemoveExtraInfo"));
 	if (p) {
 		const int nRet=p(wDocID,nIndex);
 		return nRet;
 	}
 	else
 		return -1;
}

BOOL APPHelper::SetExtraInfo(WORD wDocID, int nIndex, AML_EXTRAINFO *p)
{
	ASSERT(nIndex>=0);
	ASSERT(!IsBadReadPtr(p,sizeof(AML_EXTRAINFO)));

	const HMODULE h=GetModuleHandle(NULL);

	PFUNC_APC_SETEXTRAINFO pFunc=
		(PFUNC_APC_SETEXTRAINFO )GetProcAddress(h,TEXT("APC_SetExtraInfo"));
 	if (pFunc) {
 		const int nRet=pFunc(wDocID,nIndex,p);
 		return nRet;
 	}
 	else
		return FALSE;
}

struct GET_EXTRA_INFO_PARAM {
	AML_EXTRAINFO& ae;
	const int nIndex;
	BOOL bRet;
	GET_EXTRA_INFO_PARAM(AML_EXTRAINFO& e, int index):ae(e),nIndex(index),bRet(FALSE)
	{
	}	
};

static
BOOL GetExtraInfoProc(int nIndex, AML_EXTRAINFO* pInfo, LPARAM lParam)
{
	GET_EXTRA_INFO_PARAM* const pParam=reinterpret_cast<GET_EXTRA_INFO_PARAM*>(lParam);
	ASSERT(!IsBadWritePtr((void*)pParam,sizeof(GET_EXTRA_INFO_PARAM)));
	if (pParam->nIndex==nIndex) {
		if (pInfo->dwInfoSize) {
			pParam->ae.pInfo=new char[pInfo->dwInfoSize];
			ASSERT(!IsBadWritePtr(pParam->ae.pInfo,pInfo->dwInfoSize));
			memcpy(pParam->ae.pInfo,pInfo->pInfo,pInfo->dwInfoSize);
			pParam->ae.dwInfoSize=pInfo->dwInfoSize;
		}
		pParam->ae.nPageID=pInfo->nPageID;
		pParam->ae.stDateCreated=pInfo->stDateCreated;
		pParam->ae.stDateModified=pInfo->stDateModified;
		pParam->bRet=TRUE;
		return FALSE;
	}

	return TRUE;	
}

BOOL APPHelper::GetExtraInfo(const WORD wDocID, const int nIndex, AML_EXTRAINFO *p)
{
	ASSERT(nIndex>=0);
	ASSERT(!IsBadWritePtr(p,sizeof(AML_EXTRAINFO)));
	if(IsBadWritePtr(p,sizeof(AML_EXTRAINFO)))
		return FALSE;

	ASSERT(NULL==p->pInfo);
	ASSERT(0==p->dwInfoSize);

	GET_EXTRA_INFO_PARAM param(*p,nIndex);
	APPHelper::EnumExtraInfo (wDocID,GetExtraInfoProc,(LPARAM)&param,p->lpszInfoID,p->nPageID);

	return param.bRet;	
}
